//+------------------------------------------------------------------+
//| Squize_MA_E_mtf                                    Squize_MA.mq4 |
//| mtf:ForexTSD.com 2007                                    Kalenzo |
//| mladen's formula   ki                bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Yellow
#property indicator_color4 Goldenrod
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 5
#property indicator_width4 5



extern ENUM_TIMEFRAMES    TimeFrame        = PERIOD_CURRENT;
extern int                Ma1Period        = 5;
extern ENUM_MA_METHOD     Ma1Type          = MODE_EMA;
extern ENUM_APPLIED_PRICE Ma1Price         = PRICE_CLOSE;
extern int                Ma2Period        = 21;
extern ENUM_MA_METHOD     Ma2Type          = MODE_EMA;
extern ENUM_APPLIED_PRICE Ma2Price         = PRICE_CLOSE;
extern int                MAsThreSHoldPips = 15;
extern bool               ATRmode          = true; 
extern int                ATRperiod        = 50;
extern double             ATRmultipl       = 0.4;
extern bool               alertsOn         = true;
extern bool               alertsOnCurrent  = false;
extern bool               alertsMessage    = true;
extern bool               alertsSound      = true;
extern bool               alertsNotify     = false;
extern bool               alertsEmail      = false;
extern string             soundFile        = "alert2.wav";


double upma[];
double dnma[];
double SqLup[]; 
double SqLdn[]; 
double trend[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,upma);  SetIndexLabel(0,"SqMA1("+Ma1Period+")["+TimeFrame+"]");
   SetIndexBuffer(1,dnma);  SetIndexLabel(1,"SqMA2("+Ma2Period+")["+TimeFrame+"]");
   SetIndexBuffer(2,SqLup); SetIndexLabel(2,"SqMA Env("+MAsThreSHoldPips+")("+Ma1Period+","+Ma2Period+")["+TimeFrame+"]");
   SetIndexBuffer(3,SqLdn); SetIndexLabel(3,"SqMA Env("+MAsThreSHoldPips+")("+Ma1Period+","+Ma2Period+")["+TimeFrame+"]");
   SetIndexBuffer(4,trend);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   
   IndicatorShortName("SquizeMA ("+Ma1Period+","+Ma2Period+")["+TimeFrame+"]");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { upma[0] = limit+1; return(0); }
            if (TimeFrame!=Period())
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,TimeFrame,Time[i]); 
                      upma[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,MAsThreSHoldPips,ATRmode,ATRperiod,ATRmultipl,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
                      dnma[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,MAsThreSHoldPips,ATRmode,ATRperiod,ATRmultipl,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
                      SqLup[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,MAsThreSHoldPips,ATRmode,ATRperiod,ATRmultipl,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
                      SqLdn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Ma1Period,Ma1Type,Ma1Price,Ma2Period,Ma2Type,Ma2Price,MAsThreSHoldPips,ATRmode,ATRperiod,ATRmultipl,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);    
               }
               return(0);
            }
   
   for(i=limit; i>=0; i--)
   {
      double ma1   = iMA(NULL,0,Ma1Period,0,Ma1Type,Ma1Price,i);
      double ma2   = iMA(NULL,0,Ma2Period,0,Ma2Type,Ma2Price,i);       
      double madif = MathAbs(ma1-ma2);
 
       upma[i] = ma1;
       dnma[i] = ma2;
          
       if (ATRmode)   double delta = iATR(NULL,0,ATRperiod,i) * ATRmultipl/Point;
       else                  delta = MAsThreSHoldPips;

       trend[i] = trend[i+1];
       if(madif/Point<delta) { SqLup   [i] = ma2+ delta*Point; SqLdn   [i] = ma2- delta*Point; trend[i] = 1; }
       if(madif/Point>delta) trend[i] = -1;      
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("squeeze starting");
      else  doAlert("squeeze ending");       
   }
  return(0);
  }

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SquizeMA_Ed_FLET ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SquizeMA_Ed_FLET  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      

